#include "FKUT/FKUT.h"


int main(int argc, char *argv[])
{
	// EBhE܁[
	fkut_SimpleWindow	window;			// ϐu3DCG`EBhEɂȂϐv

	window.setSize(800, 600);			// EBhȆ傫͂D݂
	window.setBGColor(0.3, 0.6, 0.8);	// wiFR, G, B̐F0.0`1.0Ńuhč
	window.setTrackBallMode(true);		// }EXhbOŃJ肮胂[h
	window.showGuide();					// ̘gƎ\
	window.open();						// EBhÊ\
	// EBhE܂

	//////////////////////////////////////////////////////////

	// \̂pӂĂ镔
	fkut_SphereModel	body;			// 삷鋅

	body.create(8, 10.0);
	body.setMaterial(Yellow);
	body.glMoveTo(0.0, 10.0, 0.0);
	window.entry(body);

	fkut_BlockModel		floor;			// 킷ubNf

	floor.create(1000.0, 1.0, 1000.0);
	floor.glMoveTo(0.0, -0.5, 0.0);		// 傢ƒ߂ɂĂ
	floor.setMaterial(Brown);
	window.entry(floor);

	fk_Model			camera;
	camera.glMoveTo(0.0, 100.0, 200.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.setParent(&body, true);
	window.setCameraModel(camera);
	// \pӕ܂

	// ԊǗp̕ϐ
	fk_Vector	spd;			// xxNgpϐ
	int			jumpState = 0;	// 0: ӂ, 1: ㏸, 2: ~

	/////////////////////////////////////////////////////////////
	// ԂubNpӂ
	fkut_SphereModel	hitSph[5];
	fkut_BlockModel		hitBlk[5];
	fk_Vector			back;

	// zƌJԂ𗘗pāA܂Ƃ߂Đݒ
	for(int i = 0; i < 5; ++i) {
		hitSph[i].create(8, 10.0);
		hitSph[i].glMoveTo(-100.0 + i*60.0, 10.0, -50.0);
		hitSph[i].setMaterial(Red);
		window.entry(hitSph[i]);
	}
	// ̔zȂꏏ̌JԂɂ܂Ƃ߂ĂA
	// zPʂŃ[v񂵂ɂƎv
	for(int i = 0; i < 5; ++i) {
		hitBlk[i].create(15.0, 15.0, 15.0);
		hitBlk[i].glMoveTo(-100.0 + i*60.0, 7.5, 50.0);
		hitBlk[i].setMaterial(Green);
		window.entry(hitBlk[i]);
	}
	/////////////////////////////////////////////////////////////

	// 邮[
	while(window.update() == true) {
		/////////////////////////////////////////////////////////////
		// L[őO㍶Eړ
		spd.x = 0.0;
		spd.z = 0.0;

		if(window.getSpecialKeyStatus(FK_UP) == FKUT_SW_PRESS) {
			spd.z = -1.0;
		}
		if(window.getSpecialKeyStatus(FK_DOWN) == FKUT_SW_PRESS) {
			spd.z =  1.0;
		}
		if(window.getSpecialKeyStatus(FK_LEFT) == FKUT_SW_PRESS) {
			spd.x = -1.0;
		}
		if(window.getSpecialKeyStatus(FK_RIGHT) == FKUT_SW_PRESS) {
			spd.x =  1.0;
		}
		// L[쏈܂
		/////////////////////////////////////////////////////////////
		// HWv
		if(jumpState == 0) {			// ʏ탂[h
			// zL[ꂽuԁA㏸[hֈڍs
			if(window.getKeyStatus('z') == FKUT_SW_DOWN) {
				jumpState = 1;
				spd.y = 8.0;		// Wv̏x^
			}
		} else if(jumpState == 1) {	// ㏸[h
			// xω([Iȏd͉x^)
			if(spd.y > 4.0) {
				// ̑x邤͂߂Ɍ炷
				spd.y -= 1.0;
			} else if(spd.y > 0.0) {
				// xȂȂ猸炷ʂ炷
				spd.y -= 0.5;
			} else {
				// xɔ]牺~[hֈڍs
				jumpState = 2;
			}
		} else if(jumpState == 2) {	// ~[h
			// xω([Iȏd͉x^)
			if(spd.y > -4.0) {
				// ̑xȂ͂߂ɉ
				spd.y -= 0.5;
			} else {
				// xȂĂ炫߂ɉ
				spd.y -= 1.0;
			}
		}
		/////////////////////////////////////////////////////////////
		// Ƃ̓蔻菈
		if(floor.checkToMovingSphere(body, spd, back) == true) {
			spd = spd-back;
			spd.y = 0.0;
			jumpState = 0;
		}
		// ubNƂ̓蔻
		for(int i = 0; i < 5; ++i) {
			// ĂtrueԂ
			if(hitBlk[i].checkToMovingSphere(body, spd, back) == true) {
				// ubN猩߂肱݋backɓ̂ŁA
				// vC[𓮂Ēꍇ͋tɂȂ
				spd = spd-back;
				spd.y = 0.0;
				jumpState = 0;
			}
		}
		/////////////////////////////////////////////////////////////
		// ␳ς񂾑xŎۂɈړ
		body.glTranslate(spd);
		/////////////////////////////////////////////////////////////
		// d̓`FbN
		// ̑xp
		fk_Vector grav(0.0, -0.5, 0.0);
		bool fallFlag = true;

		// Ƃ̓蔻菈
		if(floor.checkToMovingSphere(body, grav, back) == true) {
			// ԂĂ痎͂Ȃ
			fallFlag = false;
		}
		// ubNƂ̓蔻
		for(int i = 0; i < 5; ++i) {
			if(hitBlk[i].checkToMovingSphere(body, grav, back) == true) {
				// ԂĂ痎͂Ȃ
				fallFlag = false;
			}
		}
		// ܂ŗĂ܂ǂ̃ubNɂԂĂȂ̂ŁA[hֈڍs
		if(fallFlag == true && jumpState == 0) {
			jumpState = 2;
		}
		/////////////////////////////////////////////////////////////
		// Ƃ̓蔻
		for(int i = 0; i < 5; ++i) {
			if(hitSph[i].checkToSphere(body, back) == true) {
				// ߂ł͂ȂAACeQbgI݂ȏz
				window.remove(hitSph[i]);
			}
		}
		/////////////////////////////////////////////////////////////
	}
	// ꂳ܂ł

	return 0;
}
